#ifndef _TABLE_H
#define _TABLE_H

struct TableEntry
{
  char *key;
  char *value;
};

class Table
{
 public:
  Table();
  ~Table();

  void put(const char *key, const char *value);

  char *get(const char *key);
  int getIndex(const char *key);
  char *getKey(int idx);
  char *getValue(int idx);

  int getSize();

 private:
  void grow();

  TableEntry *_entries;
  int _allocated;
  int _size;
};

#endif
