<?php

require("dbcommon.php");

$err=false;

if (trim($_REQUEST["STATUS"])=="OKAY")
{
  $wuid=intval($_REQUEST["WUID"]);
  $nonce=intval($_REQUEST["NONCE"]);
  $userid=$_REQUEST["USERID"];
  $proof=$_REQUEST["PROOF"];
  $cver=$_REQUEST["CVER"];

  if ($cver=="win32_barclay_2.02" || $cver=="win32_barclay_2.03"
      || $cver=="win32_barclay_2.01")
    {
      print "STATUS=FAIL\nMESSAGE=Upgrade your client!\n";
      die();
    }

  if ($wuid==0 || $nonce==0 || $userid=="")
    {
      print "STATUS=FAIL\nMESSAGE=Missing required data\n";
      die();
    }

  $query="SELECT * from workunits WHERE id=".$wuid;
  $result=mysql_query($query);

  if (!$result)
    {
      print "STATUS=FAIL\nMESSAGE=Temporary Server Error\n";
      logMessage($_SERVER,$_REQUEST,"Temp server error (2)",false);
      die();
    }

  $row=mysql_fetch_array($result);

  if ($row["nonce"]!=$nonce)
    {
      print "STATUS=FAIL\nMESSAGE=Wrong nonce.\n";
      logMessage($_SERVER,$_REQUEST,"Wrong nonce", true);
      die();
    }

  if ($row["count"]>0)
    {
      if ($row["proof"]!=$proof && $row["conflict"]==0)
	{
	  logMessage($_SERVER,$_REQUEST,"Wrong proof", true);
	  $query="UPDATE workunits SET conflict=1 WHERE id=".$row["id"];
	  mysql_query($query);
	}
    }

  $ignorestatus=array("USERID"=>1,"WUID"=>1,"NONCE"=>1,"PROOF"=>1,"STATUS"=>1);

  $status=mysql_escape_string(arraydump($_REQUEST,$ignorestatus));
  $ipaddr=mysql_escape_string($_SERVER["REMOTE_ADDR"]);
  $userid=mysql_escape_string($userid);
  $proof=mysql_escape_string($proof);

  $verifycount=$row["count"]+1;

  if ($row["count"]==0)
    {
      $query="UPDATE workunits SET credituser='$userid', count=1, status='$status', ipaddr='$ipaddr', "
	."proof='$proof', timefinished='".time()."' WHERE id=".$row["id"];

      mysql_query($query) or $err=true;
    }
  else
    {
      $query="UPDATE workunits SET count=count+1 WHERE id=".$row["id"];
      mysql_query($query) or $err=true;
    }

  if (isset($_REQUEST["SOLUTION"]))
    {
      $solution=$_REQUEST["SOLUTION"];
      $userid=$_REQUEST["USERID"];
      logMessage($_SERVER,$_REQUEST, "Found solution '".$solution."'",true);
    }


  logMessage($_SERVER,$_REQUEST,"put work ".arraydump($_REQUEST,array()),false);

  if (!$err)
    {
      print "STATUS=OKAY\n";
      //      print "MESSAGE=Thank you, come again.\n";
    }
  else
    print "STATUS=FAIL\nMESSAGE=Failure Unknown";
}
else
{
  print "STATUS=FAIL\nMESSAGE=Client reported failure";
}

function arraydump($a,$exclude)
{
  $d="";

  reset($a);
  while (list ($k,$v) = each ($a))
    {
      if (!isset($exclude[$k]))
	$d=$d."$k=$v:";
    }

  return $d;
}

function logMessage($server,$request,$message,$sendemail)
{
  $okay=true;

  $ip=$server["REMOTE_ADDR"];
  $user=$request["USERID"];
  
  $logmessage=time()."\t$user@$ip\t$message\n";

  $fd=fopen("/var/tmp/dclient/putwork.log","a");
  if (!$fd)
    $okay=false;
  flock($fd,LOCK_EX);
  if (fwrite($fd,$logmessage)<0)
    $okay=false;
  flock($fd,LOCK_UN);
  fclose($fd);
  
  if ($sendemail)
    {
      mail("eolson@mit.edu",$message,$logmessage."\n".arraydump($request,array()).arraydump($server,array()));
    }

  return $okay;
}

?>
