<html>
<head>
<title>DClient User Stats</title>
<link rel="stylesheet" title="default" href="styles.css" type="text/css">
</head>

<?php

$userid=$_REQUEST["USERID"];

$userid=substr($userid,0,16);

$fname="/var/tmp/dclient/userstats.dat";
$len=filesize($fname);
$fd=fopen("/var/tmp/dclient/userstats.dat","r");
$d=unserialize(fread($fd,$len+256));
fclose($fd);

$userstats=$d["userstats"];
$userranks=$d["userranks"];
$stats=$userstats[$userid];
$rank=$stats["rank"];

?>

<h2 id=heading>User stats for '<?php print $userid ?>'</h2>

<?php
if ($rank=="")
{
  print "<P>Sorry, I have no data for $userid. Data for that user should appear about 15 minutes after the user submits their first result.</P>";
  die();
}

print "<P>Current as of: ".date("r",$d["currentasof"]);
?>

<P>Rank overall: <?php print $rank ?>

<P>
<?php

$ranklow=max($rank-5,1);
$rankhi=min($rank+5,sizeof($userranks));

print "<table border=1 cellspacing=0>";
print "<tr><th>Rank<th>User<th>Points Overall<th>Last 24 hrs<th>Points/Sec";

for ($r=$ranklow;$r<=$rankhi;$r++)
{
  if ($r==$rank)
    print "<tr bgcolor=#ffaaaa>";
  else
    print "<tr>";

  print "<td>$r";

  print "<td>";
  print $userranks[$r];

  print "<td>";
  print $userstats[$userranks[$r]]["pointstotal"];
  print "<td>";
  if (isset($userstats[$userranks[$r]]["points24"]))
    print $userstats[$userranks[$r]]["points24"];
  else
    print "0";

  print "<td>";

  if (isset($userstats[$userranks[$r]]["points24"]))
    print round($userstats[$userranks[$r]]["points24"]/86400,2);
  else
    print "0";

}

print "</table>";

if (!isset($stats["ipstotal"]))
     $stats["ipstotal"]=0;
print "<P>IP addresses total: ".$stats["ipstotal"];

if (!isset($stats["ips24"]))
     $stats["ips24"]=0;

print "<P>IP addresses in last 24 hours: ".$stats["ips24"];

if (!isset($stats["points24"]))
     $stats["points24"]=0;

print "<P>Points per second over last 24 hours: ".round($stats["points24"]/86400,2);
print "<P>";

include("footer.php");

?>