
<?php

require("dbcommon.php");

srand(time(NULL));

if ($_REQUEST["password"]!="THEPASSWORD")
{
  die("unauthorized.");
}

print "<h2>Creating workunit</h2>\n";

$tmpfname=tempnam("/tmp","makework");
$tmpf=fopen($tempfname,"w");

$experiment=$_REQUEST["experiment"];
$priority=$_REQUEST["priority"];
$alphabet=$_REQUEST["alphabet"];
$wusize=$_REQUEST["wusize"];
$commonargs=$_REQUEST["commonargs"];
$pattern=$_REQUEST["pattern"];

$qmarks=0;
for ($i=0;$i<strlen($pattern);$i++)
{
  if ($pattern[$i]=='?')
    {
      $qmarks++;
    }
}

$seeddepth=$qmarks-$wusize;

if (!isset($experiment) || $experiment=="")
     $experiment=$pattern;

$points=intval(pow(strlen($alphabet),$qmarks-$seeddepth)/1000000);

//print "qmarks=$qmarks<br>";

if ($seeddepth<=0)
{
  print "can't handle seeddepth<=0";
  die();
}

$commonargs=$commonargs."\nALPHABET=$alphabet\nPATTERN=$pattern\n";

print "<table border=1>";
print "<tr><td>experiment<td>$experiment";
print "<tr><td>common args<td>".nl2br($commonargs);
print "<tr><td>priority<td>$priority";
print "<tr><td>pattern<td>$pattern";
print "<tr><td>work unit size<td>$wusize";
print "<tr><td>points<td>$points";
print "</table>";

$query="insert into experiments set name='$experiment', priority='$priority', application='$application', commonargs='".mysql_escape_string($commonargs)."', points='$points'";
$res=mysql_query($query);
if ($res<0)
{
  die("bad query");
}

$experimentid=mysql_insert_id();

$seed="";
for ($i=1;$i<=$seeddepth;$i++)
{
  $seed=$seed.$alphabet[0];
}

set_time_limit(0);
//mysql_query("LOCK TABLES workunits WRITE");
makeworkunits($experimentid,$alphabet,$seeddepth,0,$seed);
//mysql_query("UNLOCK TABLES");

print "<h2>Work units created</h2>";

function makeworkunits($experimentid,$alphabet, $seeddepth,$thisdepth,$seed)
{
  static $recordcount=0;

  $l=strlen($alphabet);

  for ($i=0;$i<$l;$i++)
    {
      $seed[$thisdepth]=$alphabet[$i];

      if (($thisdepth+1)<$seeddepth)
	{
	  makeworkunits($experimentid, $alphabet,$seeddepth,$thisdepth+1,$seed);
	}
      else
	{
	  $okay=0;
	  $tries=0;
	  $args="SEED=$seed";

	  while (!$okay && $tries<100)
	    {
	      $nonce=rand();
	      $randid=rand();

	      $recordcount++;
	      if ($recordcount%1000==0)
		{
		  print $recordcount."<br>\n";
		  flush();
		  ob_flush();
		  flush();
		}

	      $query="insert into workunits set randid='$randid', nonce='$nonce', experiment='$experimentid', args='".mysql_escape_string($args)."'";
	      if (!mysql_query($query))
		{
		  $tries++;
		  print "got nonce collision. trying again<br>\n";
		}
	      else
		$okay=1;
	    }
	  if (!$okay)
	    die("couldn't insert query. $query");

	}
    }
  
}